\\ Copyright 2014, 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ Using List(), not enjoyed by gp2c.
\\
pol_partial_fractions_merge(v) =
{
  my(ret=List([]));
  for(i=1,#v,
     my(p=v[i]);
     for(j=1,#ret,
        if(poldegree(denominator(p)) != poldegree(denominator(ret[j])), next());
        my(s = p + ret[j]);
        if(s==0,
           listpop(ret,j);  \\ p cancels out term in ret, remove it
           p = 0;
           break());
        if(poldegree(denominator(s)) == poldegree(denominator(p)),
           ret[j] = s;      \\ p same denominator as term in ret
           p = 0;           \\ so put the sum there
           break()));
     if(p, listput(ret,p))); \\ if p not merged then append

  ret = Vec(ret);

  \\ add-back as a check
  if(vecsum(ret) != vecsum(v),
     error("oops merged fractions don't sum, ret=",ret,
           " sum got ",vecsum(ret)," want ",vecsum(v)));

  ret
}

